.configure-k8s-office: &configure-k8s-office
  - echo $K8S_OFFICE_APISERVER_KUBELET_CLIENT_CRT | base64 -d > apiserver-kubelet-client.crt
  - echo $K8S_OFFICE_APISERVER_KUBELET_CLIENT_KEY | base64 -d  > apiserver-kubelet-client.key
  - kubectl config set-cluster k8s-office --server https://office-k8s-api.dmp-insight.com:6443 --insecure-skip-tls-verify=true
  - kubectl config set-context --cluster=k8s-office --user=kubernetes-admin k8s-office
  - kubectl config use-context k8s-office
  - kubectl config set-credentials kubernetes-admin --client-certificate=apiserver-kubelet-client.crt --client-key=apiserver-kubelet-client.key

.configure-k8s-dmp-insight-com: &configure-k8s-dmp-insight-com
  - echo $K8S_DMP_INSIGHT_APISERVER_KUBELET_CLIENT_CRT | base64 -d > apiserver-kubelet-client.crt
  - echo $K8S_DMP_INSIGHT_APISERVER_KUBELET_CLIENT_KEY | base64 -d  > apiserver-kubelet-client.key
  - kubectl config set-cluster k8s-dmp-insight-com --server https://k8s-api-lb.dmp-insight.com --insecure-skip-tls-verify=true
  - kubectl config set-context --cluster=k8s-dmp-insight-com --user=kubernetes-admin k8s-dmp-insight-com
  - kubectl config use-context k8s-dmp-insight-com
  - kubectl config set-credentials kubernetes-admin --client-certificate=apiserver-kubelet-client.crt --client-key=apiserver-kubelet-client.key

.get-secrets-from-vault: &get-secrets-from-vault
  - vault login -method=ldap -no-print username=$RUNNER_LDAP_USER password=$RUNNER_LDAP_PASSWORD
  - GITLAB_SECRET_JSON=$(vault kv get -field=dockerconfigjson infrastructure/gitlab/dockerconfigjson)
  - INGRESS_CRT=$(vault kv get -field=crt infrastructure/kubernetes/ingress/dmp-insight.com)
  - INGRESS_KEY=$(vault kv get -field=key infrastructure/kubernetes/ingress/dmp-insight.com)
  - ADMIN_POSTGRES_CONN_URL=$(vault kv get -field=admin_postgres_conn_url $VAULT_SECRET_MOUNT_POINT/$ENVIRONMENT_TYPE)
  - INGEST_POSTGRES_CONN_URL=$(vault kv get -field=ingest_postgres_conn_url $VAULT_SECRET_MOUNT_POINT/$ENVIRONMENT_TYPE)
  - PROXY_POSTGRES_CONN_URL=$(vault kv get -field=proxy_postgres_conn_url $VAULT_SECRET_MOUNT_POINT/$ENVIRONMENT_TYPE)


stages:
  - deploy


deploy-develop:
  stage: deploy
  tags: [helm3]
  before_script:
    - *configure-k8s-office
    - *get-secrets-from-vault
  variables:
    ENVIRONMENT_TYPE: develop
  script:
    - >
      helm3 upgrade --install --wait --timeout 5m --create-namespace --namespace ingest-api
      ingest-api helm-chart/ingest-api/
      --set gitlabSecret.dockerConfigJson=$(echo -n $GITLAB_SECRET_JSON | base64 -w 0)
      --set ingressSecret.crt=$(echo -n $INGRESS_CRT)
      --set ingressSecret.key=$(echo -n $INGRESS_KEY)
      --set ingest_api.postgres_conn_url=$(echo -n $INGEST_POSTGRES_CONN_URL)
      --set ingest_proxy.postgres_conn_url=$(echo -n $PROXY_POSTGRES_CONN_URL)
      --set ingest_admin.postgres_conn_url=$(echo -n $ADMIN_POSTGRES_CONN_URL)
      --values office-deploy-values.yaml
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      changes: 
        - office-deploy-values.yaml
        - helm-chart/**/*


deploy-production:
  stage: deploy
  tags: [helm3]
  before_script:
    - *configure-k8s-dmp-insight-com
    - *get-secrets-from-vault
  variables:
    ENVIRONMENT_TYPE: production
  script:
    - >
      helm3 upgrade --install --wait --timeout 5m --create-namespace --namespace ingest-api
      ingest-api helm-chart/ingest-api/
      --set gitlabSecret.dockerConfigJson=$(echo -n $GITLAB_SECRET_JSON | base64 -w 0)
      --set ingressSecret.crt=$(echo -n $INGRESS_CRT)
      --set ingressSecret.key=$(echo -n $INGRESS_KEY)
      --set ingest_api.postgres_conn_url=$(echo -n $INGEST_POSTGRES_CONN_URL)
      --set ingest_proxy.postgres_conn_url=$(echo -n $PROXY_POSTGRES_CONN_URL)
      --set ingest_admin.postgres_conn_url=$(echo -n $ADMIN_POSTGRES_CONN_URL)
      --values prod-deploy-values.yaml
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      changes: 
        - prod-deploy-values.yaml
        - helm-chart/**/*
